<template>
    <div class="w-screen h-screen bg-dark text-white px-2 overflow-y-scroll fixed">
        <template
            v-if="pageReady"
        >
            <div
                class="mx-auto text-center py-6 cursor-pointer"
                @click="$router.push({name: 'user.auth.login'})"
            >
                <img
                    :src="'/img/logo.png'"
                    class="h-24 mx-auto text-center"
                >
            </div>
            <template
                v-if="step === 1 || step === 2"
            >
                <auto-form
                    ref="form"
                    :default-data="formDefaultData"
                    :fields="fields"
                    @form-update="onFormUpdate"
                />
                <div
                    class="my-4 text-xs"
                >
                    For security purpose, never disclose your personal information e.g username, password or email to any parties
                </div>
                <div
                    v-if="referral && referral.username && referral.member_id"
                >
                    <div
                        class="text-slate-400 underline my-4 px-3"
                    >
                        <span>{{ $t('referral') }}: </span> {{ referral.username }}
                    </div>
                </div>
                <div>
                    <auto-button
                        type="primary"
                        block
                        :busy="busy"
                        :disabled="busy"
                        @click="submitForm"
                    >
                        <template
                            v-if="step === 1"
                        >
                            {{ $t('next') }}
                        </template>
                        <template
                            v-else-if="step === 2"
                        >
                            {{ $t('sign_up') }}
                        </template>
                    </auto-button>
                </div>
            </template>
            <template
                v-else
            >
                <div
                    class="text-center text-2xl capitalize font-black leading-tight my-4"
                >
                    {{ $t('sign_up_successful') }}.
                </div>
                <div
                    class="leading-tight text-center"
                >
                    {{ $t('sign_up_successful_message_1') }}
                </div>
                <div
                    class="leading-tight text-center"
                >
                    {{ $t('sign_up_successful_message_2') }}
                </div>
                <auto-button
                    type="primary"
                    block
                    class="uppercase text-2xl my-12"
                    @click="goLogin"
                >
                    {{ $t('get_started') }}
                </auto-button>
            </template>
        </template>
    </div>
</template>

<script setup>
import {computed, inject, onMounted, ref} from "vue";
import {useRoute, useRouter} from 'vue-router';
import AutoForm from '~/components/auto-form.vue';
import {useI18n} from "vue-i18n";
import {useUserStore} from "~/stores/user.js";
import {useLocaleStore} from "~/stores/locale.js";
import AutoButton from "~/components/button/auto-button.vue";
import axios from "axios";
import {useSettingStore} from "~/stores/setting.js";

const $route = useRoute();
const $router = useRouter();
const $helper = inject('$helper');

const $userStore = useUserStore();
const $localeStore = useLocaleStore();
const $settingStore = useSettingStore();

const {t} = useI18n();
const referral = ref(null);
const modelData = ref({});
const step = ref(1);
const form = ref();
const pageReady = ref(false);
const busy = ref(false);
const formDefaultData = ref({});

const fields = computed(() => {
    if (step.value === 1) {
        return [
            {
                type: 'text',
                name: 'username',
                label: t('username'),
                placeholder: t('username'),
                dark: true,
                size: 'lg'
            },
            {
                type: 'contact',
                label: t('contact_number'),
                dark: true,
                size: 'lg',
            },
            {
                type: 'email',
                name: 'email',
                label: t('email'),
                dark: true,
                size: 'lg',
            },
        ]
    } else if (step.value === 2) {
        return [
            {
                type: 'password',
                name: 'password',
                label: t('password'),
                dark: true,
                size: 'lg',
            },
            {
                type: 'password',
                name: 'password_confirmation',
                label: t('password_confirmation'),
                dark: true,
                size: 'lg',
            },
            {
                type: 'pin',
                name: 'password2',
                label: t('password2'),
                dark: true,
                size: 'lg',
            },
            {
                type: 'pin',
                name: 'password2_confirmation',
                label: t('password2_confirmation'),
                dark: true,
                size: 'lg',
            }
        ]
    } else {
        return [];
    }
})

const submitForm = async () => {
    if (!busy.value) {
        try {
            busy.value = true;

            let fd = new FormData();
            Object.keys(modelData.value).forEach(key => {
                fd.set(key, modelData.value[key]);
            });

            fd.set('step', step.value);
            fd.set('referral_member_id', referral.value.member_id);

            const resp = await axios.post('/register', fd);
            if (step.value === 1) {
                step.value = 2;
            } else if (step.value === 2) {
                //login
                await $userStore.loginAccount(resp.token);

                step.value = 3;
            }
        } catch (e) {
            if (typeof e.response.data.errors !== 'undefined') {
                form.value.setErrors(e.response.data.errors);
            }
            console.log(e);
        } finally {
            busy.value = false;
        }
    }
};

const goLogin = async () => {
    await $router.push({name: 'user.home'});
};

const onFormUpdate = (payload) => {
    if (payload instanceof FormData) {
        payload.forEach(function (value, key) {
            modelData.value[key] = value;
        });
    } else {
        modelData.value = {...payload};
    }
};

onMounted(async () => {
    const data = await axios.post('/register/build_form', {
        referral_member_id: $route.query.r,
    });

    await $settingStore.fetchSettings();

    if ($settingStore.defaultCountry) {
        formDefaultData.value.contact_country_id = String($settingStore.defaultCountry.id);
    }

    if (data.referral) {
        referral.value = data.referral;
    } else {
        await $router.push({name: 'user.login'});
    }

    pageReady.value = true;
});
</script>
